/* 
* -cr_beg-
* ********************************************************************
* IBM Confidential
* OCO Source Materials
* 5724-U38, 5724-U39, 5724-U48, 5655-V17, 5655-V19, 5655-V35, 5655-V37
* Copyright IBM Corp. 2013
* The source code for this program is not published or otherwise
* divested of its trade secrets, irrespective of what has
* been deposited with the U.S. Copyright Office.
* ********************************************************************
* -cr_end-
*/ 
#include "ioqoracledata.h"
#include "ioqoraudfinclude.h"

#ifndef __OPTIMMASK_ORA_FUNC__
#define __OPTIMMASK_ORA_FUNC__

#if defined(_CPLUSPLUS) || defined(__ZOSCPP__)
extern "C"
{
#endif
//---------------------------------------------------------------------------
// Function:   OptimMaskChar1
//
//    Desc:    Accepts 1 varchar2 data argument and a parameter string
//             returns a varchar2               
//
//-------------------------------------------------------------------------
//   Registration command for this function
//-------------------------------------------------------------------------
//create or replace function OptimMaskChar1( arg1 IN VARCHAR2, 
//                                           ParamString IN VARCHAR2) RETURN VARCHAR2
//as language C name "OptimMaskChar1" library OptimUDFMultiArgs
//WITH CONTEXT 
//parameters (
//CONTEXT, 
//ARG1 STRING, ARG1 INDICATOR short, ARG1 LENGTH int, ARG1 CHARSETID, ARG1 CHARSETFORM,
//ParamString STRING, ParamString INDICATOR short, ParamString LENGTH int, ParamString CHARSETID, ParamString CHARSETFORM,
//RETURN INDICATOR, RETURN LENGTH int, RETURN);
//-------------------------------------------------------------------------
char* OptimMaskChar1(   OCIExtProcContext *pCtx,
                        char *pArg1,        //1st Data argument
                        short sArg1Ind,
                        int iArg1Len,
                        int iArg1Cid,
                        int iArg1Cform,
                        char *pParamString, //provider-syntax string
                        short sPSInd,
                        int iPSLen,
                        int iPSCid,
                        int iPSCform,
                        short *pRetInd,
                        int *pRetLen);

//---------------------------------------------------------------------------
// Function:   OptimMaskStr2
//
//    Desc:    Accepts 2 varchar2 data argument and a parameter string
//             returns a varchar2               
//
//-------------------------------------------------------------------------
//   Registration command for this function
//-------------------------------------------------------------------------
//create or replace function OptimMaskStr2(  arg1 IN VARCHAR2, 
//                                           arg2 IN VARCHAR2, 
//                                           ParamString IN VARCHAR2) RETURN VARCHAR2
//as language C name "OptimMaskStr2" library OptimUDFMultiArgs
//WITH CONTEXT 
//parameters (
//CONTEXT, 
//ARG1 STRING, ARG1 INDICATOR short, ARG1 LENGTH int, ARG1 CHARSETID, ARG1 CHARSETFORM,
//ARG2 STRING, ARG2 INDICATOR short, ARG2 LENGTH int, ARG2 CHARSETID, ARG2 CHARSETFORM,
//ParamString STRING, ParamString INDICATOR short, ParamString LENGTH int, ParamString CHARSETID, ParamString CHARSETFORM,
//RETURN INDICATOR, RETURN LENGTH int, RETURN);
//-------------------------------------------------------------------------
char* OptimMaskStr2( OCIExtProcContext *pCtx,
                     char *pArg1,        //1st Data argument
                     short sArg1Ind,
                     int iArg1Len,
                     int iArg1Cid,
                     int iArg1Cform,
                     char *pArg2,        //2nd Data argument
                     short sArg2Ind,
                     int iArg2Len,
                     int iArg2Cid,
                     int iArg2Cform,
                     char *pParamString, //provider-syntax string
                     short sPSInd,
                     int iPSLen,
                     int iPSCid,
                     int iPSCform,
                     short *pRetInd,
                     int *pRetLen);

//---------------------------------------------------------------------------
// Function:   OptimMaskStr3
//
//    Desc:    Accepts 3 varchar2 data argument and a parameter string
//             returns a varchar2               
//
//-------------------------------------------------------------------------
//   Registration command for this function
//-------------------------------------------------------------------------
//create or replace function OptimMaskStr3(  arg1 IN VARCHAR2, 
//                                           arg2 IN VARCHAR2, 
//                                           arg3 IN VARCHAR2, 
//                                           ParamString IN VARCHAR2) RETURN VARCHAR2
//as language C name "OptimMaskStr3" library OptimUDFMultiArgs
//WITH CONTEXT 
//parameters (
//CONTEXT, 
//ARG1 STRING, ARG1 INDICATOR short, ARG1 LENGTH int, ARG1 CHARSETID, ARG1 CHARSETFORM,
//ARG2 STRING, ARG2 INDICATOR short, ARG2 LENGTH int, ARG2 CHARSETID, ARG2 CHARSETFORM,
//ARG3 STRING, ARG3 INDICATOR short, ARG3 LENGTH int, ARG3 CHARSETID, ARG3 CHARSETFORM,
//ParamString STRING, ParamString INDICATOR short, ParamString LENGTH int, ParamString CHARSETID, ParamString CHARSETFORM,
//RETURN INDICATOR, RETURN LENGTH int, RETURN);
//-------------------------------------------------------------------------
char* OptimMaskStr3( OCIExtProcContext *pCtx,
                     char *pArg1,        //1st Data argument
                     short sArg1Ind,
                     int iArg1Len,
                     int iArg1Cid,
                     int iArg1Cform,
                     char *pArg2,        //2nd Data argument
                     short sArg2Ind,
                     int iArg2Len,
                     int iArg2Cid,
                     int iArg2Cform,
                     char *pArg3,        //3rd Data argument
                     short sArg3Ind,
                     int iArg3Len,
                     int iArg3Cid,
                     int iArg3Cform,
                     char *pParamString, //provider-syntax string
                     short sPSInd,
                     int iPSLen,
                     int iPSCid,
                     int iPSCform,
                     short *pRetInd,
                     int *pRetLen);

//---------------------------------------------------------------------------
// Function:   OptimMaskStr4
//
//    Desc:    Accepts 4 varchar2 data argument and a parameter string
//             returns a varchar2               
//
//-------------------------------------------------------------------------
//   Registration command for this function
//-------------------------------------------------------------------------
//create or replace function OptimMaskStr4(  arg1 IN VARCHAR2, 
//                                           arg2 IN VARCHAR2, 
//                                           arg3 IN VARCHAR2, 
//                                           arg4 IN VARCHAR2, 
//                                           ParamString IN VARCHAR2) RETURN VARCHAR2
//as language C name "OptimMaskStr4" library OptimUDFMultiArgs
//WITH CONTEXT 
//parameters (
//CONTEXT, 
//ARG1 STRING, ARG1 INDICATOR short, ARG1 LENGTH int, ARG1 CHARSETID, ARG1 CHARSETFORM,
//ARG2 STRING, ARG2 INDICATOR short, ARG2 LENGTH int, ARG2 CHARSETID, ARG2 CHARSETFORM,
//ARG3 STRING, ARG3 INDICATOR short, ARG3 LENGTH int, ARG3 CHARSETID, ARG3 CHARSETFORM,
//ARG4 STRING, ARG4 INDICATOR short, ARG4 LENGTH int, ARG4 CHARSETID, ARG4 CHARSETFORM,
//ParamString STRING, ParamString INDICATOR short, ParamString LENGTH int, ParamString CHARSETID, ParamString CHARSETFORM,
//RETURN INDICATOR, RETURN LENGTH int, RETURN);
//-------------------------------------------------------------------------
char* OptimMaskStr4( OCIExtProcContext *pCtx,
                     char *pArg1,        //1st Data argument
                     short sArg1Ind,
                     int iArg1Len,
                     int iArg1Cid,
                     int iArg1Cform,
                     char *pArg2,        //2nd Data argument
                     short sArg2Ind,
                     int iArg2Len,
                     int iArg2Cid,
                     int iArg2Cform,
                     char *pArg3,        //3rd Data argument
                     short sArg3Ind,
                     int iArg3Len,
                     int iArg3Cid,
                     int iArg3Cform,
                     char *pArg4,        //4th Data argument
                     short sArg4Ind,
                     int iArg4Len,
                     int iArg4Cid,
                     int iArg4Cform,
                     char *pParamString, //provider-syntax string
                     short sPSInd,
                     int iPSLen,
                     int iPSCid,
                     int iPSCform,
                     short *pRetInd,
                     int *pRetLen);

//---------------------------------------------------------------------------
// Function:   OptimMaskStr5
//
//    Desc:    Accepts 5 varchar2 data argument and a parameter string
//             returns a varchar2               
//
//-------------------------------------------------------------------------
//   Registration command for this function
//-------------------------------------------------------------------------
//create or replace function OptimMaskStr5(  arg1 IN VARCHAR2, 
//                                           arg2 IN VARCHAR2, 
//                                           arg3 IN VARCHAR2, 
//                                           arg4 IN VARCHAR2, 
//                                           arg5 IN VARCHAR2, 
//                                           ParamString IN VARCHAR2) RETURN VARCHAR2
//as language C name "OptimMaskStr5" library OptimUDFMultiArgs
//WITH CONTEXT 
//parameters (
//CONTEXT, 
//ARG1 STRING, ARG1 INDICATOR short, ARG1 LENGTH int, ARG1 CHARSETID, ARG1 CHARSETFORM,
//ARG2 STRING, ARG2 INDICATOR short, ARG2 LENGTH int, ARG2 CHARSETID, ARG2 CHARSETFORM,
//ARG3 STRING, ARG3 INDICATOR short, ARG3 LENGTH int, ARG3 CHARSETID, ARG3 CHARSETFORM,
//ARG4 STRING, ARG4 INDICATOR short, ARG4 LENGTH int, ARG4 CHARSETID, ARG4 CHARSETFORM,
//ARG5 STRING, ARG5 INDICATOR short, ARG5 LENGTH int, ARG5 CHARSETID, ARG5 CHARSETFORM,
//ParamString STRING, ParamString INDICATOR short, ParamString LENGTH int, ParamString CHARSETID, ParamString CHARSETFORM,
//RETURN INDICATOR, RETURN LENGTH int, RETURN);
//-------------------------------------------------------------------------
char* OptimMaskStr5( OCIExtProcContext *pCtx,
                     char *pArg1,        //1st Data argument
                     short sArg1Ind,
                     int iArg1Len,
                     int iArg1Cid,
                     int iArg1Cform,
                     char *pArg2,        //2nd Data argument
                     short sArg2Ind,
                     int iArg2Len,
                     int iArg2Cid,
                     int iArg2Cform,
                     char *pArg3,        //3rd Data argument
                     short sArg3Ind,
                     int iArg3Len,
                     int iArg3Cid,
                     int iArg3Cform,
                     char *pArg4,        //4th Data argument
                     short sArg4Ind,
                     int iArg4Len,
                     int iArg4Cid,
                     int iArg4Cform,
                     char *pArg5,        //5th Data argument
                     short sArg5Ind,
                     int iArg5Len,
                     int iArg5Cid,
                     int iArg5Cform,
                     char *pParamString, //provider-syntax string
                     short sPSInd,
                     int iPSLen,
                     int iPSCid,
                     int iPSCform,
                     short *pRetInd,
                     int *pRetLen);

//---------------------------------------------------------------------------
// Function:   OptimMaskStr6
//
//    Desc:    Accepts 6 varchar2 data argument and a parameter string
//             returns a varchar2               
//
//-------------------------------------------------------------------------
//   Registration command for this function
//-------------------------------------------------------------------------
//create or replace function OptimMaskStr6(  arg1 IN VARCHAR2, 
//                                           arg2 IN VARCHAR2, 
//                                           arg3 IN VARCHAR2, 
//                                           arg4 IN VARCHAR2, 
//                                           arg5 IN VARCHAR2, 
//                                           arg6 IN VARCHAR2, 
//                                           ParamString IN VARCHAR2) RETURN VARCHAR2
//as language C name "OptimMaskStr6" library OptimUDFMultiArgs
//WITH CONTEXT 
//parameters (
//CONTEXT, 
//ARG1 STRING, ARG1 INDICATOR short, ARG1 LENGTH int, ARG1 CHARSETID, ARG1 CHARSETFORM,
//ARG2 STRING, ARG2 INDICATOR short, ARG2 LENGTH int, ARG2 CHARSETID, ARG2 CHARSETFORM,
//ARG3 STRING, ARG3 INDICATOR short, ARG3 LENGTH int, ARG3 CHARSETID, ARG3 CHARSETFORM,
//ARG4 STRING, ARG4 INDICATOR short, ARG4 LENGTH int, ARG4 CHARSETID, ARG4 CHARSETFORM,
//ARG5 STRING, ARG5 INDICATOR short, ARG5 LENGTH int, ARG5 CHARSETID, ARG5 CHARSETFORM,
//ARG6 STRING, ARG6 INDICATOR short, ARG6 LENGTH int, ARG6 CHARSETID, ARG6 CHARSETFORM,
//ParamString STRING, ParamString INDICATOR short, ParamString LENGTH int, ParamString CHARSETID, ParamString CHARSETFORM,
//RETURN INDICATOR, RETURN LENGTH int, RETURN);
//-------------------------------------------------------------------------
char* OptimMaskStr6( OCIExtProcContext *pCtx,
                     char *pArg1,        //1st Data argument
                     short sArg1Ind,
                     int iArg1Len,
                     int iArg1Cid,
                     int iArg1Cform,
                     char *pArg2,        //2nd Data argument
                     short sArg2Ind,
                     int iArg2Len,
                     int iArg2Cid,
                     int iArg2Cform,
                     char *pArg3,        //3rd Data argument
                     short sArg3Ind,
                     int iArg3Len,
                     int iArg3Cid,
                     int iArg3Cform,
                     char *pArg4,        //4th Data argument
                     short sArg4Ind,
                     int iArg4Len,
                     int iArg4Cid,
                     int iArg4Cform,
                     char *pArg5,        //5th Data argument
                     short sArg5Ind,
                     int iArg5Len,
                     int iArg5Cid,
                     int iArg5Cform,
                     char *pArg6,        //6th Data argument
                     short sArg6Ind,
                     int iArg6Len,
                     int iArg6Cid,
                     int iArg6Cform,
                     char *pParamString, //provider-syntax string
                     short sPSInd,
                     int iPSLen,
                     int iPSCid,
                     int iPSCform,
                     short *pRetInd,
                     int *pRetLen);

//---------------------------------------------------------------------------
// Function:   OptimMaskCharNum
//
//    Desc:    Accepts a varchar2 argument and a Oracle NUMBER argument 
//             and a parameter string
//             returns a Oracle NUMBER              
//
//-------------------------------------------------------------------------
//   Registration command for this function
//-------------------------------------------------------------------------
//create or replace function OptimMaskCharNum( arg1 IN VARCHAR2, 
//                                             arg2 IN NUMBER,
//                                             ParamString IN VARCHAR2) RETURN NUMBER
//as language C name "OptimMaskCharNum" library OptimUDFMultiArgs
//WITH CONTEXT 
//parameters (
//CONTEXT, 
//ARG1 STRING, ARG1 INDICATOR short, ARG1 LENGTH int, ARG1 CHARSETID, ARG1 CHARSETFORM,
//ARG2 OCINUMBER, ARG2 INDICATOR short,
//ParamString STRING, ParamString INDICATOR short, ParamString LENGTH int, ParamString CHARSETID, ParamString CHARSETFORM,
//RETURN INDICATOR, RETURN);
//-------------------------------------------------------------------------
OCINumber *OptimMaskCharNum(  OCIExtProcContext *pCtx,
                              char *pArg1,        //1st Data argument
                              short sArg1Ind,
                              int iArg1Len,
                              int iArg1Cid,
                              int iArg1Cform,
                              OCINumber *pArg2,   //2nd Data argument
                              short sArg2Ind,
                              char *pParamString, //provider-syntax string
                              short sPSInd,
                              int iPSLen,
                              int iPSCid,
                              int iPSCform,
                              short *pRetInd);

//---------------------------------------------------------------------------
// Function:   OptimMaskStr2Int
//
//    Desc:    Accepts 2 varchar2 data arguments and a parameter string
//             returns a Integer         
//
//-------------------------------------------------------------------------
//   Registration command for this function
//-------------------------------------------------------------------------
//create or replace function OptimMaskStr2Int( arg1 IN VARCHAR2, 
//                                             arg2 IN VARCHAR2,
//                                             ParamString IN VARCHAR2) RETURN PLS_INTEGER
//as language C name "OptimMaskStr2Int" library OptimUDFMultiArgs
//WITH CONTEXT 
//parameters (
//CONTEXT, 
//ARG1 STRING, ARG1 INDICATOR short, ARG1 LENGTH int, ARG1 CHARSETID, ARG1 CHARSETFORM,
//ARG2 STRING, ARG2 INDICATOR short, ARG2 LENGTH int, ARG2 CHARSETID, ARG2 CHARSETFORM,
//ParamString STRING, ParamString INDICATOR short, ParamString LENGTH int, ParamString CHARSETID, ParamString CHARSETFORM,
//RETURN INDICATOR, RETURN BY REFERENCE);
//-------------------------------------------------------------------------
int *OptimMaskStr2Int( OCIExtProcContext *pCtx,
                        char *pArg1,        //1st Data argument
                        short sArg1Ind,
                        int iArg1Len,
                        int iArg1Cid,
                        int iArg1Cform,
                        char *pArg2,        //2nd Data argument
                        short sArg2Ind,
                        int iArg2Len,
                        int iArg2Cid,
                        int iArg2Cform,
                        char *pParamString, //provider-syntax string
                        short sPSInd,
                        int iPSLen,
                        int iPSCid,
                        int iPSCform,
                        short *pRetInd);


//---------------------------------------------------------------------------
// Function:   OptimMaskDT1
//
//    Desc:    Accepts a TIMESTAMP argument and a parameter string
//             returns a TIMESTAMP 
//
//--------------------------------------------------------------------------- 
//    Registration command for this function
//---------------------------------------------------------------------------
//create or replace function OptimMaskTS1(arg1 in TIMESTAMP, 
//                                        ParamString in varchar2) return TIMESTAMP
//as language C name "OptimMaskTS1" library OptimUDFMultiArgs
//WITH CONTEXT
//parameters (
//CONTEXT, 
//ARG1 OCIDateTime, ARG1 INDICATOR short, 
//ParamString STRING, ParamString INDICATOR short, ParamString LENGTH int, ParamString CHARSETID, ParamString CHARSETFORM,
//RETURN INDICATOR, RETURN);
//-------------------------------------------------------------------------
OCIDateTime* OptimMaskTS1( OCIExtProcContext *pCtx,
                           OCIDateTime *pArg1,   //1st Data argument
                           short sArg1Ind,
                           char *pParamString, //provider-syntax string
                           short sPSInd,
                           int iPSLen,
                           int iPSCid,
                           int iPSCform,
                           short *pRetInd);

#if defined(_CPLUSPLUS) || defined(__ZOSCPP__)
}
#endif

#endif //__OPTIMMASK_ORA_FUNC__
